#include <Adafruit_NeoPixel.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#include <ArduinoJson.h>
#include <WiFiClientSecure.h>

#define WIFI_SSID "Wifinetwork"
#define WIFI_PASSWORD "WifiPassword"

#define PIN         D8
#define LED_COUNT   24

Adafruit_NeoPixel LED = Adafruit_NeoPixel(LED_COUNT, PIN, NEO_GRB + NEO_KHZ400);

const char *Printers[]={
 "MK3.9", "http://192.168.0.10", "Password", // My MK4 Upgrade printer
 "MK4","http://192.168.0.49:80","Password", // My first MK4 printer
 "MK4-2","http://192.168.0.106:80","Password", // My second MK4 printer
 "Mini","http://192.168.0.4:80","Password" // My Prusa Mini printer
};

ESP8266WiFiMulti D1Mini;
#define NUMPRINTERS (sizeof(Printers) / sizeof(Printers[0])/3)

void setup() {
 Serial.begin(115200);
 LED.begin();
 Blauw();
 WiFi.mode(WIFI_STA);
 D1Mini.addAP(WIFI_SSID, WIFI_PASSWORD);
 Uit(); 
}

void loop() {  
 //Aan();
 //while(1) delay(5000);
 bool Printing=false;
 if(D1Mini.run()== WL_CONNECTED){    
  WiFiClient Wifi;
  HTTPClient http;
  for(int i=0; i<NUMPRINTERS; i++) {
   Serial.printf("Checking printer %d %s...\r\n",i,Printers[i*3]);
   http.begin(Wifi,String(Printers[i*3+1])+String("/api/job"));
   http.addHeader("X-Api-Key", Printers[i*3+2]);        
   int httpCode = http.GET();
   if(httpCode > 0) {     
    String payload = http.getString();
    DynamicJsonDocument doc(1024);
    deserializeJson(doc, payload);
    String CurStatus = doc["state"].as<String>();
    if(CurStatus.indexOf("Printing")>=0) {
     Serial.printf("Printer %d %s is aan het printen\r\n",i,Printers[i*3]);
     Printing=true;
     Aan();
    }
   }
  }
 }
 if(!Printing) Uit();
 delay(20000);
}

void Aan() {
 for(int i=0; i<LED_COUNT; i++) {
  LED.setPixelColor(i,LED.Color(160,94,0));  
 } 
 LED.show();
}

void Blauw() {
 for(int i=0; i<LED_COUNT; i++) {
  LED.setPixelColor(i,LED.Color(0,0,64));  
 } 
 LED.show();
}


void Uit() {
 for(int i=0; i<LED_COUNT; i++) {
  LED.setPixelColor(i,LED.Color(0,0,0));  
 } 
 LED.show();
}
